Attribute VB_Name = "Module1"
Option Explicit

Public Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal MSG As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long

Public Const GWL_WNDPROC = (-4)
Public Const GWL_STYLE = (-16)

Public Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Public Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function RegisterClass Lib "user32" Alias "RegisterClassA" (Class As WNDCLASS) As Long
Public Declare Function UnregisterClass Lib "user32" Alias "UnregisterClassA" (ByVal lpClassName As String, ByVal hInstance As Long) As Long
Public Type WNDCLASS
    style As Long
    lpfnwndproc As Long
    cbClsextra As Long
    cbWndExtra2 As Long
    hInstance As Long
    hIcon As Long
    hCursor As Long
    hbrBackground As Long
    lpszMenuName As String
    lpszClassName As String
End Type

Public Const WS_MINIMIZEBOX = &H20000
Public Const WS_CHILD = &H40000000
Public Const WS_CLIPCHILDREN = &H2000000
Public Const WS_THICKFRAME = &H40000
Public Const WS_SYSMENU = &H80000
Public Const WS_CAPTION = &HC00000                  '  WS_BORDER Or WS_DLGFRAME
Public Const WS_OVERLAPPED = &H0&
Public Const WS_MAXIMIZEBOX = &H10000
Public Const WS_VISIBLE = &H10000000
'Public Const WS_OVERLAPPEDWINDOW = (WS_OVERLAPPED Or WS_CAPTION Or WS_SYSMENU Or WS_THICKFRAME Or WS_MINIMIZEBOX Or WS_MAXIMIZEBOX)

Public Type POINTAPI
        x As Long
        y As Long
End Type

Public Declare Function ShowWindow Lib "user32" (ByVal hwnd As Long, ByVal nCmdShow As Long) As Long
Public Declare Function UpdateWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Const SW_HIDE = 0
Public Const SW_NORMAL = 1
Public Const WS_EX_TOOLWINDOW = &H80

Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As Rect) As Long
Public Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Public Const SWP_NOMOVE = &H2
Public Const SWP_NOSIZE = &H1

Public Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long

Public Const WM_SIZE = &H5
Public Const WM_MOVE = &H3
Public Const WM_PAINT = &HF
Public Const WM_ACTIVATE = &H6
Public Const WM_MOUSEMOVE = &H200
Public Const WM_TIMER = &H113
Public Const WM_USER = &H400
Public Const WM_SETTEXT = &HC
Public Const WM_PRINT = &H317

Public Const WM_WDRAG_START = WM_USER + &HF1 '0x4F1
Public Const WM_WDRAG_MOVE = WM_USER + &HF2 '0x4F2
Public Const WM_WDRAG_END = WM_USER + &HF3 '0x4F3
Public Const WM_WDRAG_PAINT = WM_USER + &HF4 '0x4F4
Public Const WM_WDRAG_INIT = WM_USER + &HF5 '0x4F5
Public Const WM_WDRAG_TERMINATE = WM_USER + &HF6 '0x4F6

Public Const PRF_CHECKVISIBLE = &H1
Public Const PRF_NONCLIENT = &H2
Public Const PRF_CLIENT = &H4
Public Const PRF_ERASEBKGND = &H8
Public Const PRF_CHILDREN = &H10
Public Const PRF_OWNED = &H20

Public Type MSG
    hwnd As Long
    message As Long
    wParam As Long
    lParam As Long
    time As Long
    pt As POINTAPI
End Type
Public Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function GetMessage Lib "user32" Alias "GetMessageA" (lpMsg As MSG, ByVal hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long) As Long
Public Declare Function PeekMessage Lib "user32" Alias "PeekMessageA" (lpMsg As MSG, ByVal hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long, ByVal wRemoveMsg As Long) As Long

Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Public Declare Function GetWindowTextLength Lib "user32" Alias "GetWindowTextLengthA" (ByVal hwnd As Long) As Long

Public Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimerFunc As Long) As Long
Public Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long

Public Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long

Public Declare Function GetWindowExtEx Lib "gdi32" (ByVal hDC As Long, lpSize As POINTAPI) As Long

Public Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As Rect) As Long
Public Declare Function ClientToScreen Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal Destination As Long, ByVal Source As Long, ByVal Length As Long)

Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Public Const BITSPIXEL = 12         '  Number of bits per pixel
Public Const SIZEPALETTE = 104      '  Number of entries in physical palette
Public Const NUMCOLORS = 24         '  Number of colors the device supports

Public Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hDC As Long) As Long

Public Declare Function CreateBitmap Lib "gdi32" (ByVal nWidth As Long, ByVal nHeight As Long, ByVal nPlanes As Long, ByVal nBitCount As Long, lpBits As Any) As Long

Public Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Public Const PS_SOLID = 0
Public Const PS_DASH = 1                    '  -------
Public Const PS_DOT = 2                     '  .......
Public Const PS_DASHDOT = 3                 '  _._._._
Public Const PS_DASHDOTDOT = 4              '  _.._.._

Public Declare Function SelectObject Lib "gdi32" (ByVal hDC As Long, ByVal hObject As Long) As Long

Public Declare Function GetRgnBox Lib "gdi32" (ByVal hRgn As Long, lpRect As Rect) As Long

Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long

Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hDC As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hDC As Long) As Long

Public Declare Function DeleteDC Lib "gdi32" (ByVal hDC As Long) As Long

Public Declare Function Rectangle Lib "gdi32" (ByVal hDC As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long


Public Const GW_OWNER = 4
Public Declare Function GetWindow_api Lib "user32" Alias "GetWindow" (ByVal hwnd As Long, ByVal wCmd As Long) As Long
Public Const DRAW_WINDOW_CLASS32 = "DRAW_WINDOW_CLASS32"
Public Type DrawWindowInfo
    hwnd As Long
    hDC As Long
    hBitmap As Long
    Width As Long
    Height As Long
End Type

Public Sub GetWindowWorkRect(ByVal hwnd As Long, ByRef lpRect As Rect)
GetClientRect hwnd, lpRect
Dim mPoints(1) As POINTAPI
CopyMemory VarPtr(mPoints(0)), VarPtr(lpRect), 16
ClientToScreen hwnd, mPoints(0)
ClientToScreen hwnd, mPoints(1)
CopyMemory VarPtr(lpRect), VarPtr(mPoints(0)), 16
End Sub

Public Function PointInRect(ByRef nRect As Rect, ByRef nPoint As POINTAPI) As Boolean
    PointInRect = (nPoint.x > nRect.Left And nPoint.x < nRect.Right) And (nPoint.y > nRect.Top And nPoint.y < nRect.Bottom)
End Function


Public Sub RegisterDrawWindowClass()
Dim wCls As WNDCLASS
wCls.hInstance = App.hInstance
wCls.lpszClassName = DRAW_WINDOW_CLASS32
wCls.lpfnwndproc = GetWndPrcAddr_DrawMethod_
If RegisterClass(wCls) = 0 Then Err.Raise 11, , "Can't register draw_window_class32"
End Sub

Public Sub UnregisterDrawWindowClass()
If UnregisterClass(DRAW_WINDOW_CLASS32, App.hInstance) = 0 Then Err.Raise 11, , "Can't unregister draw_window_class32"
End Sub

Public Function GetWndPrcAddr_DrawMethod_() As Long
GetWndPrcAddr_DrawMethod_ = ReturnValue__(AddressOf WndPrc__)
End Function

Public Function CreateDrawWindow(ByVal nParent As Long) As DrawWindowInfo
Dim nRect As Rect, ret As DrawWindowInfo
GetClientRect nParent, nRect
ret.Width = nRect.Right - nRect.Left
ret.Height = nRect.Bottom - nRect.Top
ret.hwnd = CreateWindowEx(0, DRAW_WINDOW_CLASS32, "draw_wnd", WS_VISIBLE, 0, 0, ret.Width, ret.Height, 0, 0, App.hInstance, ByVal 0&)
'ShowWindow CreateDrawWindow.hWnd, 0

Dim nTempDC As Long ', nTempWnd As Long
'nTempWnd = GetWindow_api(nParent, GW_OWNER)
nTempDC = GetDC(nParent)
ret.hDC = CreateCompatibleDC(nTempDC)
ret.hBitmap = CreateCompatibleBitmap(nTempDC, ret.Width, ret.Height)
SelectObject ret.hDC, ret.hBitmap
Debug.Print GetDeviceCaps(ret.hDC, NUMCOLORS)
SendMessage nParent, WM_PRINT, ret.hDC, ByVal CLng(PRF_OWNED Or PRF_CHILDREN Or PRF_NONCLIENT Or PRF_CLIENT Or PRF_ERASEBKGND)
'BitBlt ret.hDC, 0, 0, ret.Width, ret.Height, nTempDC, 0, 0, vbSrcCopy
ReleaseDC nParent, nTempDC
CreateDrawWindow = ret
End Function

Public Sub DestroyDrawWindow(ByRef aWindow As DrawWindowInfo)
DeleteObject aWindow.hBitmap
DeleteDC aWindow.hDC
DestroyWindow aWindow.hwnd
End Sub

Private Function WndPrc__(ByVal hwnd As Long, ByVal uMsg As Long, ByVal uwParam As Long, ByVal ulParam As Long) As Long
WndPrc__ = DefWindowProc(hwnd, uMsg, uwParam, ulParam)
End Function

Public Function ReturnValue__(ByVal aVal As Long) As Long
ReturnValue__ = aVal
End Function
